<?php
/**
*
* @author Culprit (Jan) jankalach@gmail.com 
* @package umil
* @version $Id top_topics_mod_install.php 1.3.0-RC1 2009-01-19 10:07:40GMT Culprit $
* @copyright (c) 2009 Culprit 
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('');

if (!file_exists($phpbb_root_path . 'umil/umil.' . $phpEx))
{
	trigger_error('Please download the latest UMIL (Unified MOD Install Library) from: <a href="http://www.phpbb.com/mods/umil/">phpBB.com/mods/umil</a>', E_USER_ERROR);
}

// We only allow a founder to install this MOD
if ($user->data['user_type'] != USER_FOUNDER)
{
	if ($user->data['user_id'] == ANONYMOUS)
	{
		login_box('', 'LOGIN');
	}

	trigger_error('NOT_AUTHORISED');
}

if (!class_exists('umil'))
{
	include($phpbb_root_path . 'umil/umil.' . $phpEx);
}

$umil = new umil(true);

$mod = array(
	'name'		=> 'Top Topics',
	'version'	=> '1.3.0-RC1',
	'config'	=> 'top_topics_version',
	'enable'	=> 'top_topics_enable',
);

if (confirm_box(true))
{
	// Install the base 1.3.0-RC1 version
	if (!$umil->config_exists($mod['config']))
	{
		// Lets add a config setting for enabling/disabling the MOD and set it to true
		$umil->config_add($mod['enable'], true);

		// We must handle the version number ourselves.
		$umil->config_add($mod['config'], $mod['version']);


		$umil->table_add($table_prefix . 'top_topic_order', array(
			'COLUMNS'	=> array(
				'tt_id'		=> array('UINT', '', 'auto_increment'),
				'tt_order'		=> array('UINT', ''),
				'tt_display'		=> array('UINT', 1),
				'tt_title'		=> array('VCHAR', ''),
				'tt_sql'		=> array('XSTEXT_UNI', ''),
				'tt_additional'		=> array('XSTEXT_UNI', ''),
			),
		));

		$umil->config_add('tt_count', '5', '0');

		$umil->config_add('tt_aligment', 'top', '0');

		$umil->config_add('tt_logged', '1', '0');

		$umil->config_add('tt_width', '200', '0');

		$umif->module_add(array(
			array('ACP_CAT_DOT_MODS', 'CAT_TOP_TOPICS', 
				array('module_basename'	=> 'SETTINGS'),
			),
		));

		// Our final action, we purge the board cache
		$umil->cache_purge();
	}

	// We are done
	trigger_error('Done!');
}
else
{
	confirm_box(false, 'INSTALL_TEST_MOD');
}

// Shouldn't get here.
redirect($phpbb_root_path . $user->page['page_name']);


?>