<?php

/**
*
* @package phpBB3
* @version $Id:$
* @copyright (c) 2008 Culprit
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/
/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}


class acp_top_topics
{
	var $u_action;
	var $new_config = array();
	
	function tt_aligment($selected_value, $key)
	{
		global $user;
		
		return '<option value="top"' . ( ($selected_value == 'top') ? ' selected': '') .'>' . $user->lang['TT_TOP'] . '</option>
		<option value="right"' . ( ($selected_value == 'right') ? ' selected': '') .'>' . $user->lang['TT_RIGHT'] . '</option>
		<option value="left"' . ( ($selected_value == 'left') ? ' selected': '') .'>' . $user->lang['TT_LEFT'] . '</option>
		';
	}

	function main($id, $mode)
	{
		global $user, $template;

		$user->add_lang( array('acp/common', 'mods/top_topics'));


		$form_key = 'acp_top_topics';
		add_form_key($form_key);

		$this->tpl_name = 'acp_top_topics';
		$this->page_title = $user->lang['TOP_TOPICS'] . ' :: ' . $user->lang['SETTINGS'];


		if ( isset( $_POST['addtt'])) // CHANGE Order to addnew module
		{
 
		}
		$template->assign_var( 'U_ACTION_MAIN', $this->u_action);
		switch ( $mode) {
			case 'settings':
				$template->assign_var( 'MODE', $mode);
				$this->settings( $id);
				break;
			case 'order':
				$action = request_var( 'action', '');
				if ( in_array( $action, array( 'addnew', 'edit')))
				{
					$template->assign_var( 'MODE', 'edit');
					$this->edit( $id);
					break;
				}
				$template->assign_var( 'MODE', $mode);
				$this->order( $id);
				break;
		}
		$template->assign_var( 'U_ACTION', $this->u_action);
		return;
	}
	
	function settings( $id)
	{
		global $cache, $db, $user, $auth, $template;
		global $config, $phpbb_root_path, $phpbb_admin_path, $phpEx;

		if ( !isset($config['tt_count']) )
		{
			set_config( 'tt_count', 5);
			set_config( 'tt_aligment', 'top');
			set_config( 'tt_logged', 1);
			set_config( 'tt_width', 200);
		}

		$display_vars = array(
			'title'	=> 'SETTINGS',
			'vars'	=> array(
				'tt_count'		=> array('lang' => 'TT_COUNT',		'validate' => 'int',	'type' => 'text:4:4',	'explain' => true),
				'tt_aligment'	=> array('lang' => 'TT_ALIGMENT',	'validate' => 'string',	'type' => 'select',		'method' => 'tt_aligment', 'explain' => true),
				'tt_logged'		=> array('lang' => 'TT_USER_LOGGED','validate' => 'int',	'type' => 'radio:yes_no', 'explain' => true),
				'tt_width'		=> array('lang' => 'TT_WIDTH',		'validate' => 'int',	'type' => 'text:3:3',	'append' => ' px', 'explain' => true),					
			)
		);

		if (isset($display_vars['lang']))
		{
			$user->add_lang($display_vars['lang']);
		}

		$action	= request_var('action', '');
		$submit = (isset($_POST['submit'])) ? true : false;

		$this->new_config = $config;
		$cfg_array = (isset($_REQUEST['config'])) ? utf8_normalize_nfc(request_var('config', array('' => ''), true)) : $this->new_config;
		$error = array();

		// We validate the complete config if whished
		validate_config_vars($display_vars['vars'], $cfg_array, $error);
		if (sizeof($error))
		{
			$submit = false;
		}
		foreach ($display_vars['vars'] as $config_name => $null)
		{
			if (!isset($cfg_array[$config_name]) || strpos($config_name, 'legend') !== false)
			{
				continue;
			}
			
			$this->new_config[$config_name] = $config_value = $cfg_array[$config_name];

			if ($submit)
			{
				set_config($config_name, $config_value);
			}
		}

		$config_name = 'tt_order';

		if ( $submit)
		{
			$cache->destroy( '_global');
			trigger_error( sprintf( $user->lang['TT_SETTINGS_UPDATED'], $user->lang['CONFIG_UPDATED'], $this->u_action, $user->lang['BACK']));			
		}
		
		foreach ($display_vars['vars'] as $config_key => $vars)
		{
			if (!is_array($vars) && strpos($config_key, 'legend') === false)
			{
				continue;
			}

			if (strpos($config_key, 'legend') !== false)
			{
				$template->assign_block_vars('options', array(
					'S_LEGEND'		=> true,
					'LEGEND'		=> (isset($user->lang[$vars])) ? $user->lang[$vars] : $vars)
				);

				continue;
			}

			$type = explode(':', $vars['type']);

			$l_explain = '';
			if ($vars['explain'] && isset($vars['lang_explain']))
			{
				$l_explain = (isset($user->lang[$vars['lang_explain']])) ? $user->lang[$vars['lang_explain']] : $vars['lang_explain'];
			}
			else if ($vars['explain'])
			{
				$l_explain = (isset($user->lang[$vars['lang'] . '_EXPLAIN'])) ? $user->lang[$vars['lang'] . '_EXPLAIN'] : '';
			}
			
			$content = build_cfg_template($type, $config_key, $this->new_config, $config_key, $vars);
			
			if (empty($content))
			{
				continue;
			}
			
			$template->assign_block_vars('options', array(
				'KEY'			=> $config_key,
				'TITLE'			=> (isset($user->lang[$vars['lang']])) ? $user->lang[$vars['lang']] : $vars['lang'],
				'S_EXPLAIN'		=> $vars['explain'],
				'TITLE_EXPLAIN'	=> $l_explain,
				'CONTENT'		=> build_cfg_template($type, $config_key, $this->new_config, $config_key, $vars),
				)
			);

			unset($display_vars['vars'][$config_key]);
		}
	}

	function order( $id)
	{
		global $user, $db, $template, $cache;

		$action = request_var( 'action', '');

		if ( $action != '')
		{
			$tt_id = request_var( 'tt_id', 0);
			$tt_order = request_var( 'tt_order', 0);
			switch( $action)
			{
				case 'moveup':
					$sql1 = "UPDATE " . TT_ORDER_TABLE . " SET tt_order = '" . ($tt_order + 1) . "' WHERE tt_order = '{$tt_order}'";
					$sql2 = "UPDATE " . TT_ORDER_TABLE . " SET tt_order = '{$tt_order}' WHERE tt_id = '{$tt_id}'";
					break;
				case 'movedn':
					$sql1 = "UPDATE " . TT_ORDER_TABLE . " SET tt_order = '" . ($tt_order - 1) . "' WHERE tt_order = '{$tt_order}'";
					$sql2 = "UPDATE " . TT_ORDER_TABLE . " SET tt_order = '{$tt_order}' WHERE tt_id = '{$tt_id}'";
					break;
			}

			$db->sql_query( $sql1);
			$db->sql_query( $sql2);
			$cache->destroy( '_top_topics');
		}
		
		$sql = "SELECT * FROM " . TT_ORDER_TABLE . " ORDER BY tt_order";
		$rs = $db->sql_query( $sql);
		$rowset = $db->sql_fetchrowset( $rs);
		$db->sql_freeresult( $rs);
		
		$row_count = count( $rowset);
		
		foreach( $rowset as $key => $row)
		{
			$template->assign_block_vars( 'order', array(
				'S_FIRST_ROW'		=> ((0 == $key) ? 1: 0),
				'S_LAST_ROW'		=> (($row_count - 1 == $key) ? 1: 0),
				
				'U_MOVE_DOWN'		=> $this->u_action . "&amp;action=movedn&amp;tt_id={$row[tt_id]}&amp;tt_order=" . ( $row['tt_order'] + 1), 
				'U_MOVE_UP'			=> $this->u_action . "&amp;action=moveup&amp;tt_id={$row[tt_id]}&amp;tt_order=" . ( $row['tt_order'] - 1),
				
				'U_EDIT'			=> $this->u_action . "&amp;action=edit&amp;tt_id={$row[tt_id]}",
				
				'TITLE'				=> $user->lang[$row['tt_title']],
				'S_DISPLAYED'		=> ($row['tt_display'] == 1 )? true:false,
				));
		}
		
	}
	
	function edit( $id)
	{
		global $user, $db, $template;
		global $phpbb_root_path, $phpEx;
		
		$action = request_var( 'action', 'edit');
		$tt_id = request_var( 'tt_id', 0);

		switch ( $action)
		{
			case 'addnew':
				$tt_row = array(
					'tt_id'			=> 0,
					'tt_order'		=> 0,
					'tt_display'	=> 1,
					'tt_title'		=> $_POST['tt_name'],
					'tt_sql'		=> '',
					'tt_additional'	=> '',
					'tt_goto'		=> 0,
					);
				break;
			case 'edit':
				if ( !$tt_id || $tt_id == 0)
				{
					trigger_error( $user->lang['TT_NOTHING_TO_EDIT']);
				}
				
				if ( isset( $_POST['edit']))
				{
					$data = $_POST['config'];

					if ( !$tt_id)
					{
						$rs = $db->sql_query( 'SELECT MAX(tt_order) AS maxorder FROM ' . TT_ORDER_TABLE);
						$row = $db->sql_fetchrow( $rs);
						$db->sql_freeresult( $rs);
						
						$sql_type = 'INSERT';
						$sql = "INSERT INTO " . TT_ORDER_TABLE;
						
						$sql_ary = array(
							'tt_order' => (int) $row['maxorder'] + 1,
							);
						$sql_where = '';
						
					}
					else
					{
						$sql_type = 'UPDATE';
						$sql = "UPDATE " . TT_ORDER_TABLE . " SET ";
						$sql_ary = array();
						$sql_where = " WHERE tt_id = '{$tt_id}'";
					}

					$sql_ary = array_merge( array(
						'tt_title'	=> $data['tt_title'],
						'tt_sql'	=> $data['tt_sql'],
						'tt_display'=> $data['tt_display'],
						'tt_additional'	=> $data['tt_additional'],
						'tt_goto'	=> $data['tt_goto'], 
						), $sql_ary);

					$sql .= $db->sql_build_array( $sql_type, $sql_ary) . $sql_where;
					//die( $sql);
					$db->sql_query( $sql);
					
					trigger_error( sprintf( $user->lang['TT_SETTINGS_UPDATED'], $user->lang['CONFIG_UPDATED'], $this->u_action, $user->lang['BACK']));			
					
				}

				$sql = "SELECT * FROM " . TT_ORDER_TABLE . " WHERE tt_id = '{$tt_id}'";
				$rs = $db->sql_query_limit( $sql, 1);
				$tt_row = $db->sql_fetchrow( $rs);
				$db->sql_freeresult( $rs);

				break;
		}
		
		include( "{$phpbb_root_path}includes/mods/functions_top_topics.{$phpEx}");
		$sql_values = array();
		foreach( $sql_tt_avails as $key => $value)
		{
			$sql_values[$key] = $key;
			$user->lang[$key] = $key;
		}
	
	
		foreach( $goto_ary as $key => $value)
		{
			if ( isset( $user->lang[strtoupper($value)]))
			{
				$goto_ary[$key] = strtoupper($value);
			}
			else
			{
			$user->lang[$value] = $value;
			}
		}
	
		$display_vars = array(
			'title'	=> 'EDIT',
			'vars'	=> array(
				'tt_title'		=> array('lang' => 'TT_TITLE',		'validate' => 'string',	'type' => 'text', 'append' =>  ' (' . $user->lang[$tt_row['tt_title']] . ')', 'explain' => true),
				'tt_sql'		=> array('lang' => 'TT_SQL',		'validate' => 'string',	'type' => 'select', 'function' => 'build_select', 'params' => array( $sql_values, $tt_row['tt_sql']), 'explain' => true),
				'tt_additional'	=> array('lang' => 'TT_ADDITIONAL',	'validate' => 'string',	'type' => 'text', 'explain' => true),
				'tt_display'	=> array('lang' => 'TT_DISPLAY',	'validate' => 'int',	'type' => 'radio:yes_no', 'explain' => true),
				'tt_goto'		=> array('lang' => 'GOTO',			'validate' => 'string', 'type' => 'select', 'function' => 'build_select', 'params' => array( $goto_ary, $tt_row['tt_goto']), 'explain' => true),					
			)
		);

		foreach ($display_vars['vars'] as $config_key => $vars)
		{
			if (!is_array($vars) && strpos($config_key, 'legend') === false)
			{
				continue;
			}

			if (strpos($config_key, 'legend') !== false)
			{
				$template->assign_block_vars('options', array(
					'S_LEGEND'		=> true,
					'LEGEND'		=> (isset($user->lang[$vars])) ? $user->lang[$vars] : $vars)
				);

				continue;
			}

			$type = explode(':', $vars['type']);

			$l_explain = '';
			if ($vars['explain'] && isset($vars['lang_explain']))
			{
				$l_explain = (isset($user->lang[$vars['lang_explain']])) ? $user->lang[$vars['lang_explain']] : $vars['lang_explain'];
			}
			else if ($vars['explain'])
			{
				$l_explain = (isset($user->lang[$vars['lang'] . '_EXPLAIN'])) ? $user->lang[$vars['lang'] . '_EXPLAIN'] : '';
			}
			
			$content = build_cfg_template($type, $config_key, $tt_row, $config_key, $vars);
			
			if (empty($content))
			{
				continue;
			}
			
			$template->assign_block_vars('options', array(
				'KEY'			=> $config_key,
				'TITLE'			=> (isset($user->lang[$vars['lang']])) ? $user->lang[$vars['lang']] : $vars['lang'],
				'S_EXPLAIN'		=> $vars['explain'],
				'TITLE_EXPLAIN'	=> $l_explain,
				'CONTENT'		=> build_cfg_template($type, $config_key, $tt_row, $config_key, $vars),
				)
			);

			unset($display_vars['vars'][$config_key]);
		}

		$template->assign_vars( array(
			'TT_ID'		=> $tt_row['tt_id'],
			'TT_ORDER'	=> $tt_row['tt_order'],
		 ));
		
	}
	
}
?>
