<?php
/**
*
* @author Culprit (Jan) jankalach@gmail.com 
* @package umil
* @version $Id top_topics_mod_install.php 1.3.0-RC1 2009-01-19 10:07:40GMT Culprit $
* @copyright (c) 2009 Culprit 
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
define('UMIL_AUTO', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('install');

if (!file_exists($phpbb_root_path . 'umil/umil.' . $phpEx))
{
	trigger_error('Please download the latest UMIL (Unified MOD Install Library) from: <a href="http://www.phpbb.com/mods/umil/">phpBB.com/mods/umil</a>', E_USER_ERROR);
}

// We only allow a founder to install this MOD
if ($user->data['user_type'] != USER_FOUNDER)
{
	if ($user->data['user_id'] == ANONYMOUS)
	{
		login_box('', 'LOGIN');
	}

	trigger_error('NOT_AUTHORISED');
}

if (!class_exists('umil'))
{
	include($phpbb_root_path . 'umil/umil.' . $phpEx);
}

$umil = new umil(true);

$mod = array(
	'name'		=> 'Top Topics',
	'version'	=> '1.3.0-RC1',
	'config'	=> 'top_topics_version_1.3RC1',
	'enable'	=> 'top_topics_enable',
);

if (confirm_box(true))
{
	// Install the base 1.3.0-RC1 version
	//if (!$umil->config_exists($mod['config']))
	{
		// Lets add a config setting for enabling/disabling the MOD and set it to true
		$umil->config_add($mod['enable'], true);

		// We must handle the version number ourselves.
		$umil->config_add($mod['config'], $mod['version']);


		$umil->table_add( 'phpbb_top_topics_order', array(
			'COLUMNS'	=> array(
				'tt_id'		=> array('UINT', null, 'auto_increment'),
				'tt_order'		=> array('UINT', null),
				'tt_display'		=> array('UINT', 1),
				'tt_title'		=> array('VCHAR', ''),
				'tt_sql'		=> array('XSTEXT_UNI', ''),
				'tt_additional'		=> array('XSTEXT_UNI', ''),
				'tt_goto'		=> array('UINT', 0),
			),
			'KEYS'	=> array(
				'tt_id' => array( 'INDEX', array( 'tt_id')),
				'tt_ord' => array( 'UNIQUE', array( 'tt_id', 'tt_order')),
			),
		));

		$sql_ary[1] = array(
		 	'tt_order'		=> 1,
			'tt_title'		=> 'TOP_TOPIC_TOPICS',
			'tt_sql'		=> 'sql_topics',
			'tt_display'	=> 1,
			'tt_additional'	=> '',
			'tt_goto'		=> 0, 
			);
		$sql_ary[2] = array(
		 	'tt_order'		=> 2,
			'tt_title'		=> 'TOP_TOPIC_REPLIES',
			'tt_sql'		=> 'sql_replies',
			'tt_display'	=> 1,
			'tt_additional'	=> 'topic_replies',
			'tt_goto'		=> 0, 
			);
		$sql_ary[3] = array(
		 	'tt_order'		=> 3,
			'tt_title'		=> 'TOP_TOPIC_VIEWS',
			'tt_sql'		=> 'sql_views',
			'tt_display'	=> 1,
			'tt_additional'	=> 'topic_views',
			'tt_goto'		=> 0, 
			);
		$sql_ary[4] = array(
		 	'tt_order'		=> 4,
			'tt_title'		=> 'TOP_TOPIC_POSTS',
			'tt_sql'		=> 'sql_posts',
			'tt_display'	=> 1,
			'tt_additional'	=> '',
			'tt_goto'		=> 2, 
			);
			
		foreach( $sql_ary as $data)
		{
			$sql = $db->sql_build_array( 'INSERT', $data );
			$db->sql_query( "INSERT INTO " . TT_ORDER_TABLE . $sql);
		}

		$umil->config_add('tt_count', '5', false);

		$umil->config_add('tt_aligment', 'top', false);

		$umil->config_add('tt_logged', '1', false);

		$umil->config_add('tt_width', '200', false);

		if ( !$umil->module_exists( 'acp', 31, 'ACP_TOP_TOPICS') )
		{
			$umil->module_add( 'acp', 31, array(
				'module_enabled'		=> 1,
				'module_display'		=> 1,
				'module_basename'		=> '',
				'module_class'			=> 'acp',
				'parent_id'				=> 31,
				'module_langname'		=> 'ACP_TOP_TOPICS',
				'module_mode'			=> '',
				'module_auth'			=> 'acl_a_board',
			));

			$umil->module_add(
				'acp',
				$db->sql_nextid(),
				array( 'module_basename'	=> 'top_topics',
					'modes' => array( 'settings', 'order'))
			);
		}

		// Our final action, we purge the board cache
		$umil->cache_purge();
	}

	// We are done
	trigger_error('Done!');
}
else
{
	confirm_box(false, $user->lang['CAT_INSTALL'] . ': ' . $mod['name'] . ' ' . $mod['version']);
}

// Shouldn't get here.
redirect($phpbb_root_path . $user->page['page_name']);


?>